#define INCL_WIN
#define INCL_GPI
#define INCL_DOS
#include <os2.h>
#include "sysclr_r.h"

HAB  hab;
HWND hwndFrame;

struct {
LONG lIndex;
PSZ  pszTitle;
} aSysColors[] = {
    SYSCLR_ENTRYFIELD ,
       "Entry field and list box background color.",

    SYSCLR_MENUDISABLEDTEXT ,
       "Menu item background color.",

    SYSCLR_MENUHILITE ,
       "Selected menu item text.",

    SYSCLR_MENUHILITEBGND ,
       "Selected menu item background.",

    SYSCLR_PAGEBACKGROUND ,
       "Notebook page background.",

    SYSCLR_FIELDBACKGROUND ,
       "Inactive scroll bar and default control background color.",

    SYSCLR_BUTTONLIGHT ,
       "Light pushbutton (3D effect).",

    SYSCLR_BUTTONMIDDLE ,
       "Middle pushbutton (3D effect).",

    SYSCLR_BUTTONDARK ,
       "Dark pushbutton (3D effect).",

    SYSCLR_BUTTONDEFAULT ,
       "Pushbutton.",

    SYSCLR_TITLEBOTTOM ,
       "Line drawn under title bar.",

    SYSCLR_SHADOW ,
       "Drop shadow for menus and dialogs.",

    SYSCLR_ICONTEXT, 
       "Text written under icons on the desktop.",

    SYSCLR_DIALOGBACKGROUND ,
       "Pop up dialog box background.",

    SYSCLR_HILITEFOREGROUND ,
       "Selection foreground.",

    SYSCLR_HILITEBACKGROUND ,
       "Selection background.",

//   #define SYSCLR_INACTIVETITLETEXTBGND    (-31L)
//   #define SYSCLR_ACTIVETITLETEXTBGND      (-30L)

    SYSCLR_INACTIVETITLETEXTBGND ,
       "Background of inactive title text.",

    SYSCLR_ACTIVETITLETEXTBGND ,
       "Background of active title text.",

    SYSCLR_INACTIVETITLETEXT ,
       "Inactive title text.",

    SYSCLR_ACTIVETITLETEXT ,
       "Active title text.",

    SYSCLR_OUTPUTTEXT ,
       "Output text.",

    SYSCLR_WINDOWSTATICTEXT ,
       "Static (nonselectable) text.",

    SYSCLR_SCROLLBAR ,
       "Active scroll bar background area.",

    SYSCLR_BACKGROUND ,
       "Desktop background.",

    SYSCLR_ACTIVETITLE ,
       "Active window title.",

    SYSCLR_INACTIVETITLE ,
       "Inactive window title.",

    SYSCLR_MENU ,
       "Menu background.",

    SYSCLR_WINDOW ,
       "Window background.",

    SYSCLR_WINDOWFRAME ,
       "Window frame (border line).",

    SYSCLR_MENUTEXT ,
       "Normal menu item text.",

    SYSCLR_WINDOWTEXT ,
       "Window text.",

    SYSCLR_TITLETEXT ,
       "Text in title bar, size box, scroll bar arrow box.",

    SYSCLR_ACTIVEBORDER ,
       "Border fill of active window.",

    SYSCLR_INACTIVEBORDER ,
       "Border fill of inactive window.",

    SYSCLR_APPWORKSPACE ,
       "Background of specific main windows.",

    SYSCLR_HELPBACKGROUND ,
       "Background of help panels.",

    SYSCLR_HELPTEXT ,
       "Help text.",

    SYSCLR_HELPHILITE ,
       "Highlighted help text.",

    SYSCLR_SHADOWHILITEBGND ,
       "Shadows of workplace object background highlight color.",

    SYSCLR_SHADOWHILITEFGND ,
       "Shadows of workplace object foreground highlight color.",

    SYSCLR_SHADOWTEXT ,
       "Shadows of workplace object text color."
};

LONG alTmp[SYSCLR_CSYSCOLORS*2];

LONG aSysClr[SYSCLR_CSYSCOLORS];

MRESULT EXPENTRY MainDialogProc( HWND hwnd,
                                 ULONG msg,
                                 MPARAM mp1,
                                 MPARAM mp2)
{
INT i;
static INT iClrNumber = -1;
LONG tmp;
HPOINTER hIcon;

   switch (msg)
   {
   case WM_INITDLG:
      hIcon = WinLoadPointer( HWND_DESKTOP,NULLHANDLE, 100 );
      WinSendMsg( hwnd, WM_SETICON, (MPARAM)hIcon, NULL );
      for( i=0; i<SYSCLR_CSYSCOLORS; i++ )
      {
      aSysClr[i] = WinQuerySysColor( HWND_DESKTOP, aSysColors[i].lIndex, 0 );
      WinSendDlgItemMsg( hwnd, 102, LM_INSERTITEM, MPFROMSHORT( LIT_END ),
                         MPFROMP( aSysColors[i].pszTitle ) );
      }

      // Undocumented. Color selection control messages. (Warp4 and Older)
      WinSendDlgItemMsg( hwnd, 104, 0x0602, (MPARAM)aSysClr[0], (MPARAM)0L );
      WinSendDlgItemMsg( hwnd, 104, 0x1384, (MPARAM)aSysClr[0], (MPARAM)0L );

      WinSendDlgItemMsg( hwnd, 106, SPBM_SETLIMITS, (MPARAM)255L, (MPARAM)0L );
      WinSendDlgItemMsg( hwnd, 108, SPBM_SETLIMITS, (MPARAM)255L, (MPARAM)0L );
      WinSendDlgItemMsg( hwnd, 110, SPBM_SETLIMITS, (MPARAM)255L, (MPARAM)0L );

      WinSendDlgItemMsg( hwnd, 106, SPBM_SETCURRENTVALUE,
			 (MPARAM)((aSysClr[0]>>16) & 255L), (MPARAM)0L );
      WinSendDlgItemMsg( hwnd, 108, SPBM_SETCURRENTVALUE,
			 (MPARAM)((aSysClr[0]>>8) & 255L), (MPARAM)0L );
      WinSendDlgItemMsg( hwnd, 110, SPBM_SETCURRENTVALUE,
			 (MPARAM)(aSysClr[0] & 255L), (MPARAM)0L );

      break;

   // undocumented messages (from color selection control). See os2undoc.inf.
   case 0x0601:
   case 0x130C:
      if( iClrNumber < 0 ) break;
      aSysClr[iClrNumber] = (LONG)mp1;
      WinSendDlgItemMsg( hwnd, 106, SPBM_SETCURRENTVALUE,
			 (MPARAM)((aSysClr[iClrNumber]>>16) & 255L), (MPARAM)0L );
      WinSendDlgItemMsg( hwnd, 108, SPBM_SETCURRENTVALUE,
			 (MPARAM)((aSysClr[iClrNumber]>>8) & 255L), (MPARAM)0L );
      WinSendDlgItemMsg( hwnd, 110, SPBM_SETCURRENTVALUE,
			 (MPARAM)(aSysClr[iClrNumber] & 255L), (MPARAM)0L );
      break;

   case WM_CONTROL:
      if((SHORT1FROMMP(mp1) == 102) && (SHORT2FROMMP(mp1) == LN_SELECT))
      {
      iClrNumber = (INT)WinSendDlgItemMsg( hwnd, 102, LM_QUERYSELECTION,
					   MPFROMSHORT(LIT_FIRST), (MPARAM)0L );

      // Undocumented. Color selection control messages. (Warp4 and Older)
      WinSendDlgItemMsg( hwnd, 104, 0x0602, (MPARAM)aSysClr[iClrNumber], (MPARAM)0L );
      WinSendDlgItemMsg( hwnd, 104, 0x1384, (MPARAM)aSysClr[iClrNumber], (MPARAM)0L );

      WinSendDlgItemMsg( hwnd, 106, SPBM_SETCURRENTVALUE,
			 (MPARAM)((aSysClr[iClrNumber]>>16) & 255L), (MPARAM)0L );
      WinSendDlgItemMsg( hwnd, 108, SPBM_SETCURRENTVALUE,
			 (MPARAM)((aSysClr[iClrNumber]>>8) & 255L), (MPARAM)0L );
      WinSendDlgItemMsg( hwnd, 110, SPBM_SETCURRENTVALUE,
			 (MPARAM)(aSysClr[iClrNumber] & 255L), (MPARAM)0L );
      }
      if((SHORT1FROMMP(mp1) == 106) && (SHORT2FROMMP(mp1) == SPBN_CHANGE))
      {
      if( iClrNumber < 0 ) break;
      aSysClr[iClrNumber] &= 0x0000FFFF;
      WinSendDlgItemMsg( hwnd, 106, SPBM_QUERYVALUE,
                         (MPARAM)&tmp, MPFROM2SHORT( 0, SPBQ_UPDATEIFVALID ) );
      aSysClr[iClrNumber] |= tmp<<16;
      }
      if((SHORT1FROMMP(mp1) == 108) && (SHORT2FROMMP(mp1) == SPBN_CHANGE))
      {
      if( iClrNumber < 0 ) break;
      aSysClr[iClrNumber] &= 0x00FF00FF;
      WinSendDlgItemMsg( hwnd, 108, SPBM_QUERYVALUE,
                         (MPARAM)&tmp, MPFROM2SHORT( 0, SPBQ_UPDATEIFVALID ) );
      aSysClr[iClrNumber] |= tmp<<8;
      }

      if((SHORT1FROMMP(mp1) == 110) && (SHORT2FROMMP(mp1) == SPBN_CHANGE))
      {
      if( iClrNumber < 0 ) break;
      aSysClr[iClrNumber] &= 0x00FFFF00;
      WinSendDlgItemMsg( hwnd, 110, SPBM_QUERYVALUE,
                         (MPARAM)&tmp, MPFROM2SHORT( 0, SPBQ_UPDATEIFVALID ) );
      aSysClr[iClrNumber] |= tmp;
      }

      if( (SHORT2FROMMP(mp1) == SPBN_CHANGE) &&
	  ((SHORT1FROMMP(mp1) == 106) ||
	   (SHORT1FROMMP(mp1) == 108) ||
	   (SHORT1FROMMP(mp1) == 110)) )
      {
      if( iClrNumber < 0 ) break;
      // Undocumented. Color selection control messages. (Warp4 and Older)
      WinSendDlgItemMsg( hwnd, 104, 0x0602, (MPARAM)aSysClr[iClrNumber], (MPARAM)0L );
      WinSendDlgItemMsg( hwnd, 104, 0x1384, (MPARAM)aSysClr[iClrNumber], (MPARAM)0L );
      }

      break;

   case WM_COMMAND:

      switch( (SHORT)mp1 )
      {
      case DID_OK:

      for( i=0; i<SYSCLR_CSYSCOLORS; i++ )
      {
      alTmp[i*2] = aSysColors[i].lIndex;
      alTmp[i*2+1] = aSysClr[i];
      }
      
      WinSetSysColors( HWND_DESKTOP, 0, LCOLF_INDRGB,
		       aSysColors[0].lIndex, SYSCLR_CSYSCOLORS*2, alTmp );
      break;

      case DID_CANCEL:

      WinPostMsg( hwnd, WM_QUIT, 0L, 0L );
      break;
      }
      
      return (MRESULT) 0L;

   case WM_CLOSE:

      WinPostMsg( hwnd, WM_QUIT, 0L, 0L );
      return( FALSE );

   } /* end switch */

   /* Pass messages on to the frame window
    */
   return ( WinDefDlgProc( hwnd, msg, mp1, mp2 ) );

} /* End MainDialogProc */

int main()
{
HMQ          hmq;
QMSG         qmsg;
HMODULE	     hmWpConfig;
CHAR	     szError[256];

hab = WinInitialize( 0 );
hmq = WinCreateMsgQueue( hab, 0 );


// load color selection control dll
DosLoadModule( szError, 256, "WPCONFIG", &hmWpConfig );

hwndFrame = WinLoadDlg( HWND_DESKTOP,
                        HWND_DESKTOP,
                        ( PFNWP )MainDialogProc,
                        NULLHANDLE,
                        IDR_MAINDIALOG,
                        NULL );


while ( WinGetMsg( hab, &qmsg, NULL, 0, 0 ) )
        WinDispatchMsg( hab, &qmsg );

DosFreeModule ( hmWpConfig );

WinDestroyWindow( hwndFrame );
WinDestroyMsgQueue( hmq );
WinTerminate( hab );
return 0;
}